#define STRUCT
#include <windows.h>
#include "1.rc"
#define false 0
#define true 1
typedef int bool;

struct vector
{
  int x;
  int y;
};

LRESULT CALLBACK  WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void DrawStudyExample(HWND hWnd);
POINT CalcBezierCurve(vector* pts, const double& t, int kol);
int GetNumberOfPoint (int x, int y, vector* P, int kol);
void DrawBezier(HDC hdc, vector* pts, int kol);



int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmd, int nCmdShow)
{
	MSG msg;
	HWND hWnd;
	WNDCLASS WndClass;
	WndClass.style=NULL;
	WndClass.lpfnWndProc=WndProc;
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hInstance=hInstance;
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.lpszMenuName="MENU_1";
	WndClass.lpszClassName="StudEx";
	//if(!RegisterClass(&WndClass)) return 0;
	RegisterClass(&WndClass);
	hWnd=CreateWindow("StudEx","Grafika",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,400,300,NULL,NULL,hInstance,NULL);
	if (!hWnd)return NULL;
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&msg,NULL,NULL,NULL))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam)
{

  static bool IsSelected = false; 	//  ,   ,    
						//     .   - "",  .

  static vector pts[20];		// - ,     .
  static int kol = -1;                  //    

  HDC hdc;				//  .
  PAINTSTRUCT ps;

  switch(message)
  {
		  case WM_LBUTTONDOWN:
	//    .
	//     ,      
	//      .
	if (!IsSelected) {
		hdc = GetDC(hWnd);

		vector tmp;
		tmp.x = LOWORD(lParam);
		tmp.y = HIWORD(lParam);
		pts[++kol] = tmp;

		Ellipse(hdc, pts[kol].x-5, pts[kol].y-5, pts[kol].x+5, pts[kol].y+5);

		ReleaseDC(hWnd, hdc);
		}
	 break;

	 case WM_MOUSEMOVE:
	 //    ,   ,     
	 //    (   "Draw curve").
	 if (IsSelected) {
		//       ,
		if (wParam && MK_LBUTTON) {
			hdc = GetDC (hWnd);

			//     ,        .
			int mnp = GetNumberOfPoint(LOWORD(lParam), HIWORD(lParam), pts, kol);
			if (mnp < 0) break;

			//          .
			pts[mnp].x = LOWORD (lParam) ;
			pts[mnp].y = HIWORD (lParam) ;

			//       , , ,  .
			SendMessage(hWnd, WM_PAINT, NULL, NULL);
			ReleaseDC (hWnd, hdc);
			}
		}
			 break;

	 case WM_COMMAND:
	 switch (LOWORD(wParam))
	 {
		/*case 201:
		 DrawStudyExample(hWnd);
		 break;*/
		case ID_CURVE_DRAWCURVE:
		//  Curve -> Draw curve
		//      , . .      , 
		//    .
		if (kol == -1) {
				MessageBox(hWnd, "There is necessary to put at least one point to client area of window!",
							"An error occured!", NULL);
				break;
			}
			//  -   IsSelected  "" (,     )
		IsSelected = true;
		//   .
		SendMessage(hWnd, WM_PAINT, NULL, NULL);
		break;
		case ID_CURVE_NEWCURVE:
		//  Curve -> New curve
		//   , IsSelected  ""   .
		kol = -1;
		IsSelected = false;
		SendMessage(hWnd, WM_PAINT, NULL, NULL);
		break;
		case 108:
			 DestroyWindow(hWnd);
			 break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	 }
	 break;

	 case WM_PAINT:
		//    .

		//      .
		InvalidateRect(hWnd, NULL, TRUE);

		hdc = BeginPaint(hWnd, &ps);

		//     ,      .
		if (kol != -1)
			DrawBezier(hdc, pts, kol) ;

		EndPaint(hWnd, &ps);
		break;


	  case WM_DESTROY:
		PostQuitMessage(0); 		break;
		default:return DefWindowProc(hWnd,message,wParam,lParam);
  }
  return 0L;
}
